#!/usr/bin/python

##Copyright (C) 2004  by Phillip Deneault <deneault@hiddengroup.net>

#    This file is part of Placid.

#    Placid is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    Placid is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Placid; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys              #system module
import string           #string module
import MySQLdb
import MySQLdb.cursors
import cgi
import time
import socket
import os

import cgitb; cgitb.enable()

def printheader():

        print "Content-Type: text/html\n\n"  #reports a web page
        print "<html>\n"
        print "<head><title>Placid</title></head>\n"
        print "<body bgcolor=\"ffffff\">\n"
        print "<table border=0 width=100%><tr><td><b><font size=+2>Placid 2.0</font></b> by Phil Deneault at <a href=\"mailto:deneault@hiddengroup.net?subject=Placid Topic\">deneault@hiddengroup.net</a></td>"
        print "<td><a href=\"placid.py\">[ Home ]</a><nobr><nobr><a href=\"search.py\">[ Search ]</a><nobr><nobr><!--<a href=\"delete.py\">[ Delete ]</a>--></td>"
        print "</tr></table>\n"

def printtail():
	print "</body>\n"
	print "</html>\n"

def qryevent(cid, sid):
	
	global db

	cur=db.cursor(MySQLdb.cursors.DictCursor)
	query = "select date_format(event.timestamp, \"%Y%m%d%H%i%S\") AS timestamp, sensor.hostname AS hostname, inet_ntoa(iphdr.ip_src) AS src, inet_ntoa(iphdr.ip_dst) AS dst, iphdr.ip_ver AS ver, iphdr.ip_hlen AS hlen, iphdr.ip_tos AS tos, iphdr.ip_len AS len, iphdr.ip_id AS id, iphdr.ip_flags AS flags, iphdr.ip_off AS off, iphdr.ip_ttl AS ttl, iphdr.ip_proto AS proto, iphdr.ip_csum AS csum, sensor.interface AS inter, signature.sig_name AS signame, signature.sig_sid as sigid from event,sensor,iphdr,signature where signature.sig_id=event.signature and iphdr.sid=event.sid and iphdr.cid=event.cid and sensor.sid=event.sid and event.cid=" + cid + " and event.sid=" + sid + ";"
	cur.execute(query)
	temp = cur.fetchone()
	return temp

def qryoptions(cid, sid):

	global db

        cur=db.cursor(MySQLdb.cursors.DictCursor)
        query = "select * from opt where sid=" + str(sid) + " and cid=" + str(cid) + ";"
        cur.execute(query)
        temp = cur.fetchall()
        return temp


def hextranslate(s):
        res = ""
        for i in range(len(s)/2):
                realIdx = i*2
                tmpstr = s[realIdx:realIdx+2]

                if tmpstr[0] == "A":
                        tmpnum1 = 16*10
                elif tmpstr[0] == "B":
                        tmpnum1 = 16*11
                elif tmpstr[0] == "C":
                        tmpnum1 = 16*12
                elif tmpstr[0] == "D":
                        tmpnum1 = 16*13
                elif tmpstr[0] == "E":
                        tmpnum1 = 16*14
                elif tmpstr[0] == "F":
                        tmpnum1 = 16*15
                else:
                        tmpnum1 = int(tmpstr[0])*16
                if tmpstr[1] == "A":
                        tmpnum2 = 10
                elif tmpstr[1] == "B":   
                        tmpnum2 = 11
                elif tmpstr[1] == "C": 
                        tmpnum2 = 12
                elif tmpstr[1] == "D":
                        tmpnum2 = 13
                elif tmpstr[1] == "E":
                        tmpnum2 = 14
                elif tmpstr[1] == "F":
                        tmpnum2 = 15
                else:
                        tmpnum2 = int(tmpstr[1])
		if (tmpnum1 + tmpnum2) == 47:
			res = res + "&#47;"
		elif (tmpnum1 + tmpnum2) == 92:
                        res = res + "&#92;"
		elif (tmpnum1 + tmpnum2) == 60:
			res = res + "&lt;"
		elif (tmpnum1 + tmpnum2) == 62:
                        res = res + "&gt;"
                elif ((tmpnum1 + tmpnum2) > 126) | ((tmpnum1 + tmpnum2) < 32):
                        res = res + "."
                else:
                        res = res + chr(tmpnum1 + tmpnum2)
        return res


def main():

	printheader()
	global db

        options = {}

        fin = open("./placid.cfg")
        line = fin.readline()
        while line:
                if line[0] != "#":
                        tmp = string.split(line, "=")
                        options[tmp[0]] = string.strip(tmp[1])
                line = fin.readline()
        fin.close()

	plugins = {}

        fin = open("./plugins.cfg")
        line = fin.readline()
        while line:
                if line[0] != "#" and string.strip(line) != "":
                        tmp = string.split(line, "|")
                        plugins[string.strip(tmp[0])] = string.strip(tmp[1])
                line = fin.readline()
        fin.close() 

	db = MySQLdb.connect(host=options['dbhost'],db=options['db'],passwd=options['passwd'],user=options['user'],port=int(options['port']))

	form = cgi.FieldStorage()

	for i in form.keys():
		form[i].value = string.strip(form[i].value)

	if form.has_key("cid") and form.has_key("sid") and not form.has_key("plugin") and not form.has_key("ascii"):
		cid = form['cid'].value 
		sid = form['sid'].value
	
		event = qryevent(cid,sid)
		protoopts = qryoptions(cid,sid)

		print "<table border=0><tr>"
		print "<td>"
                print "<form method=post action=\"event.py\">"
                print "<input type=hidden name=\"ascii\" value=\"0\">"
                print "<input type=hidden name=\"cid\" value=\"" + cid + "\">"
                print "<input type=hidden name=\"sid\" value=\"" + sid + "\">"
                print "<input value=\"ASCII\" type=submit></form>"
                print "</td>"
		for i in plugins.keys():
			print "<td>"
			print "<form method=post action=\"event.py\">"
			print "<input type=hidden name=\"plugin\" value=\"" +i + "\">"
			print "<input type=hidden name=\"cid\" value=\"" + cid + "\">"
			print "<input type=hidden name=\"sid\" value=\"" + sid + "\">"
			print "<input value=\"" + i + "\" type=submit></form>"
			print "</td>"
		print "</tr><table>"
		
		for i in event.keys():
			event[i] = str(event[i])
	
		print "<table><tr bgcolor=#ffbbbb><td>META</td><td>"
		print "<table border=1 width=100%><b><tr><td>SID</td><td>CID</td><td>TimeStamp</td><td>Signature</td><td>Sig ID</td></b></tr>"
		print "<tr><td>" + sid + "</td><td>" + cid + "</td><td>" + time.strftime("%Y-%m-%d %H:%M:%S", time.strptime(str(event['timestamp']), "%Y%m%d%H%M%S")) + "</td><td>" + event['signame'] + "</td><td><a href=\"http://www.snort.org/snort-db/sid.html?sid=" + event['sigid'] + "\">" + event['sigid'] + "</a></td></tr></table>"
		print "<table border=1 width=100%><b><tr><td>Sensor Hostname</td><td>Sensor Interface</td></tr></b>"
		print "<tr><td>" + event['hostname'] + "</td><td>" + event['inter'] + "</td></tr></table>"
		print "</td></tr>"	
	
		print "<tr bgcolor=#bbffbb><td>IP</td><td>"
		print "<table border=1 width=100%><b><tr><td>Source Address</td><td>Dest Address</td><td>Ver</td><td>Hdr Len</td><td>TOS</td><td>length</td><td>ID</td><td>flags</td><td>offset</td><td>TTL</td><td>chksum</td></tr></b>"
		print "<tr><td>" + event['src'] + "</td><td>" + event['dst'] + "</td><td>" + event['ver'] + "</td><td>" + event['hlen'] + "</td><td>" + event['tos'] + "</td><td>" + event['len'] + "</td><td>" + event['id'] + "</td><td>" + event['flags'] + "</td><td>" + event['off'] + "</td><td>" + event['ttl'] + "</td><td>" + event['csum'] + "</td></tr></table>"
		print "<table border=1 width=100%><b><tr><td>Resolved Source</td><td>Resolved Dest</td></tr></b>"
		print "<tr><td>",
		try:	
			print str(socket.gethostbyaddr(event['src'])[0]),
		except:
			print "Could Not Resolve"
		print "</td><td>",
		try:
			print str(socket.gethostbyaddr(event['dst'])[0]),
		except:
			print "Could Not Resolve"
		print "</td></tr></table>"
	
		print "</td></tr>"
	
		if event['proto'] == "1":
			cur=db.cursor(MySQLdb.cursors.DictCursor)
	        	query = "select icmp_type, icmp_code, icmp_csum, icmp_id, icmp_seq from icmphdr where icmphdr.cid=" + cid + " and icmphdr.sid=" + sid + ";"
			try:
		        	cur.execute(query)
		        	temp = cur.fetchone()		
				for i in temp.keys():
					temp[i] = str(temp[i])
				print "<tr bgcolor=#bbbbff><td>ICMP</td><td>"
				print "<table border=1 width=100%><b><tr><td>ICMP type</td><td>ICMP Code</td><td>ICMP checksum</td><td>ICMP ID</td><td>ICMP Seq</td></tr></b>"
				print "<tr><td>" + temp['icmp_type'] + "</td><td>" + temp['icmp_code'] + "</td><td>" + temp['icmp_csum'] + "</td><td>" + temp['icmp_id'] + "</td><td>" + temp['icmp_seq'] + "</td></tr></table>" 
			        print "</td></tr>"
			except:
				print "<tr bgcolor=#bbbbff><td>ICMP</td><td>"
	                        print "<table border=1 width=100%><b><tr><td>ICMP type</td><td>ICMP Code</td><td>ICMP checksum</td><td>ICMP ID</td><td>ICMP Seq</td></tr></b></table></td></tr>"
		elif event['proto'] == "6":
	                cur=db.cursor(MySQLdb.cursors.DictCursor)
	                query = "select tcp_sport,tcp_dport,tcp_seq,tcp_ack,tcp_off,tcp_res,tcp_flags,tcp_win,tcp_csum,tcp_urp from tcphdr where tcphdr.cid=" + cid + " and tcphdr.sid=" + sid + ";"
			try:
		                cur.execute(query)
		                temp = cur.fetchone()
		                for i in temp.keys():
		                        temp[i] = str(temp[i])	                
		                print "<tr bgcolor=#bbbbff><td>TCP</td><td>"
				print "<table border=1 width=100%><b><tr><td>Source Port</td><td>Dest Port</td><td>Seq</td><td>Ack</td><td>Offset</td><td>Reserved</td><td>Flags</td><td>Window</td><td>Checksum</td><td>Urgent Ptr</td></tr></b>"	
				print "<tr><td>" + temp['tcp_sport'] + "</td><td>" + temp['tcp_dport'] + "</td><td>" + str(temp['tcp_seq']) + "</td><td>" + str(temp['tcp_ack']) + "</td><td>" + temp['tcp_off'] + "</td><td>" + temp['tcp_res'] + "</td><td>" + temp['tcp_flags'] + "</td><td>" + temp['tcp_win'] + "</td><td>" + temp['tcp_csum'] + "</td><td>" + temp['tcp_urp'] + "</td></tr></table>"
				print "<table border=1>"
				print "<tr><td colspan=4>Options</td></tr>"
				if list(protoopts):
					print "<tr><td>##</td><td>Code</td><td>Length</td><td>Data</td></tr>"
					for i in protoopts:
						if i["opt_proto"] == 6:
							print "<tr><td>" + str(i['optid']) + "</td><td>" 
							if i['opt_code'] == 0:
								print "End of Option List"
							elif i['opt_code'] == 1:
								print "No Operation"
							elif i['opt_code'] == 2:
								print "Maximum Segment Size"
							elif i['opt_code'] == 3:
								print "WSOPT - Window Scale"
							elif i['opt_code'] == 4:
								print "SACK Permitted"
							elif i['opt_code'] == 5:
								print "SACK"
							elif i['opt_code'] == 6:
								print "Echo (obsoleted by option 8)"
							elif i['opt_code'] == 7:
								print "Echo Reply (obsoleted by option 8)"
							elif i['opt_code'] == 8:
								print "TSOPT - Time Stamp Option"
							elif i['opt_code'] == 9:
								print "Partial Order Connection Permitted"
							elif i['opt_code'] == 10:
								print "Partial Order Service Profile"
							elif i['opt_code'] == 14:
								print "TCP Alternate Checksum Request"
							elif i['opt_code'] == 15:
								print "TCP Alternate Checksum Data"
							elif i['opt_code'] == 18:
								print "Trailer Checksum Option"
							elif i['opt_code'] == 19:
								print "MD5 Signature Option"
							else:
								print "Suspicious...take a deeper look"
							print "</td><td>" + str(i['opt_len']) + "</td><td>" + str(i['opt_data']) + "</td></tr>"
				else:
					print "<tr><td colspan=4>None</td></tr>"
				print "</table>"
				print "<table border=1>"	
	                        print "<tr><td colspan=8>Flags</td></tr>"
				print "<tr><td colspan=8>"
				if temp['tcp_flags'] == 0:	
					print "None"
				else:	
					counter = int(temp['tcp_flags'])
					downcounter=7		
					tmp = 0
					binstr = ""
					while downcounter >= 0:
						tmp = counter / (2**downcounter)
						binstr = binstr + str(tmp)
						counter = counter % (2**downcounter)	
						downcounter = downcounter - 1
					tmpstr = ""
					print "<tr><td>RB 1</td><td>RB 0</td><td>URG</td><td>ACK</td><td>PSH</td><td>RST</td><td>SYN</td><td>FIN</td></tr>"
					print "<tr>"
					for i in binstr:
						if i == "1":
							print "<td align=center>X</td>"
						elif i == "0":
							print "<td></td>"					
				print "</td></tr>"
				print "</table>"	

	       	                print "</td></tr>"
			except:
		                print "<tr bgcolor=#bbbbff><td>TCP</td><td>"
				print "<table border=1 width=100%><b><tr><td>Source Port</td><td>Dest Port</td><td>Seq</td><td>Ack</td><td>Offset</td><td>Reserved</td><td>Flags</td><td>Window</td><td>Checksum</td><td>Urgent Ptr</td></tr></b></table></td></tr>"
		elif event['proto'] == "17":
			cur=db.cursor(MySQLdb.cursors.DictCursor)
		        query = "select udp_sport,udp_dport,udp_len,udp_csum from udphdr where udphdr.cid=" + cid + " and udphdr.sid=" + sid + ";"
			try: 
		                cur.execute(query)
		                temp = cur.fetchone()	
		                for i in temp.keys():
	       	 	                temp[i] = str(temp[i])
				print "<tr bgcolor=#bbbbff><td>UDP</td><td>"        
				print "<table border=1 width=100%><b><tr><td>Source Port</td><td>Dest Port</td><td>Length</td><td>Checksum</td></tr></b>"
				print "<tr><td>" + temp['udp_sport'] + "</td><td>" + temp['udp_dport'] + "</td><td>" + temp['udp_len'] + "</td><td>" + temp['udp_csum'] + "</td></tr></table>"
				print "</td></tr>"
			except:
				print "<tr bgcolor=#bbbbff><td>UDP</td><td>"        
				print "<table border=1 width=100%><b><tr><td>Source Port</td><td>Dest Port</td><td>Length</td><td>Checksum</td></tr></b></table></td></tr>"

		print "<tr bgcolor=#bbffff><td>DATA</td><td>"
		cur=db.cursor(MySQLdb.cursors.DictCursor)
		query = "select data_payload from data where data.cid=" + cid + " and data.sid=" + sid + ";"
		cur.execute(query)
		temp = cur.fetchone()
		tmpstr = ""									
	
		hexdata = ""
		asciidata = ""
	
		if temp:
			for i in temp['data_payload']:	
				tmpstr = tmpstr + i
			count = 0
			paylen = len(tmpstr)
			tmp = ""
			for i in range(0, paylen):
				if (count == paylen-1):
					fin = 0
					tmp = tmp + tmpstr[i]
					hexdata = hexdata + tmp + "<br>\n"  
					asciidata = asciidata + hextranslate(tmp) + "<br>\n"
					tmp = ""
					count = 0
				elif count < 19:
					tmp = tmp + tmpstr[i]
					count = count + 1
					fin = 1
				else:
					fin = 0
					tmp = tmp + tmpstr[i]
					hexdata = hexdata + tmp + "<br>\n" 
					asciidata = asciidata + hextranslate(tmp) + "<br>\n"
					tmp = ""
					count = 0
			if fin == 1:
				hexdata = hexdata + tmp + "<br>\n"
				asciidata = asciidata + hextranslate(tmp) + "<br>\n"
			print "<table>"
			print "<tr><td><pre>"
			print hexdata 
			print "</pre></td><td><pre>"
			print asciidata
			print "</pre></td></tr></table>"
			print "</td></tr></table>"
			if options["eventaltviews"] == 'yes':
				print "<hr><table>"
				print "<tr bgcolor=#bbffff><td>DATA</td><td>"
				print "<pre>"
				count = 0
				paylen = len(tmpstr)
				tmp = ""
				asciidata1 = ""
				for i in range(0, paylen):
		                        if (count == paylen-1):
						fin = 0 
		                                tmp = tmp + tmpstr[i]
		                                asciidata1 = asciidata1 + hextranslate(tmp) + "<br>"
		                                tmp = ""  
		                                count = 0
		                        elif count < 119:
		                                tmp = tmp + tmpstr[i]
		                                count = count + 1
						fin = 1
		                        else:
						fin = 0
		                                tmp = tmp + tmpstr[i]
		                                asciidata1 = asciidata1 + hextranslate(tmp) + "<br>"
		                                tmp = ""
		                                count = 0
		                if fin == 1:
       	 	                	asciidata1 = asciidata1 + hextranslate(tmp) + "<br>\n"
				print asciidata1
				print "</pre>"
				print "</td></tr></table>"
		else:
			print "None"
			print "</td></tr></table>"

	elif form.has_key("plugin"):
		plugintouse = form["plugin"]
		temp = plugins[form["plugin"].value]
		event = qryevent(form['cid'].value,form['sid'].value)	
		temp = string.replace(temp, "<sid>", form['sid'].value)
		temp = string.replace(temp, "<cid>", form['cid'].value)
		temp = string.replace(temp, "<srcip>", event['src'])
		temp = string.replace(temp, "<dstip>", event['dst'])
		temp = string.replace(temp, "<Time>", event['timestamp'])
		print string.split(string.strip(temp), " ", 1)[1]
		os.execv(string.split(string.strip(temp), " ", 1)[0], ("", string.split(string.strip(temp), " ", 1)[1]))
	elif form.has_key("ascii"):
		cid = form['cid'].value
		sid = form['sid'].value
		event = qryevent(cid,sid)
		protoopts = qryoptions(cid,sid)
		print "<pre>"
		
		for i in event.keys():
			event[i] = str(event[i])
	
		print "META"
		print "--------"
		print "SID\tCID\tTimeStamp\t\tSignature"
		print sid + "\t" + cid + "\t" + time.strftime("%Y-%m-%d %H:%M:%S", time.strptime(str(event['timestamp']), "%Y%m%d%H%M%S")) + "\t" + event['signame']
		print "Sig ID"
		print event['sigid'] +"\n"

		print "Sensor Hostname\t\t\t\tSensor Interface"
		print event['hostname'] + "\t" + event['inter'] + "\n"
	
		print "IP"
		print "--------"
		print "Source Address\tDest Address\tVer\tHdr Len"
		print event['src'] + "\t" + event['dst'] + "\t" + event['ver'] + "\t" + event['hlen']
		print "TOS\tlength\tID\tflags\toffset\tTTL\tchksum"
		print event['tos'] + "\t" + event['len'] + "\t" + event['id'] + "\t" + event['flags'] + "\t" + event['off'] + "\t" + event['ttl'] + "\t" + event['csum'] + "\n"

		print "Resolved Source"
		try:	
			print str(socket.gethostbyaddr(event['src'])[0]) + "\n"
		except:
			print "Could Not Resolve"
		print "Resolved Dest"
		try:
			print str(socket.gethostbyaddr(event['dst'])[0]),
		except:
			print "Could Not Resolve"
		print "\n"
	
	
		if event['proto'] == "1":
			cur=db.cursor(MySQLdb.cursors.DictCursor)
	        	query = "select icmp_type, icmp_code, icmp_csum, icmp_id, icmp_seq from icmphdr where icmphdr.cid=" + cid + " and icmphdr.sid=" + sid + ";"
			try:
		        	cur.execute(query)
		        	temp = cur.fetchone()		
				for i in temp.keys():
					temp[i] = str(temp[i])
				print "ICMP"
				print "--------"
				print "ICMP type\tICMP Code\tICMP checksum\tICMP ID\tICMP Seq"
				print temp['icmp_type'] + "\t" + temp['icmp_code'] + "\t" + temp['icmp_csum'] + "\t" + temp['icmp_id'] + "\t" + temp['icmp_seq'] + "\n" 
			except:
				print "ICMP"
				print "--------"
		elif event['proto'] == "6":
	                cur=db.cursor(MySQLdb.cursors.DictCursor)
	                query = "select tcp_sport,tcp_dport,tcp_seq,tcp_ack,tcp_off,tcp_res,tcp_flags,tcp_win,tcp_csum,tcp_urp from tcphdr where tcphdr.cid=" + cid + " and tcphdr.sid=" + sid + ";"
			try:
		                cur.execute(query)
		                temp = cur.fetchone()
		                for i in temp.keys():
		                        temp[i] = str(temp[i])	                
		                print "TCP"
				print "--------"
				print "Source Port\tDest Port\tSeq\t\tAck\t\t"
				print temp['tcp_sport'] + "\t\t" + temp['tcp_dport'] + "\t\t" + str(temp['tcp_seq']) + "\t" + str(temp['tcp_ack']) 
				print "Offset\tReserved\tFlags\tWindow\tChecksum\tUrgent Ptr"	
				print temp['tcp_off'] + "\t" + temp['tcp_res'] + "\t\t" + temp['tcp_flags'] + "\t" + temp['tcp_win'] + "\t" + temp['tcp_csum'] + "\t\t" + temp['tcp_urp'] + "\n"

				print "Options"
				print "--------"
				if list(protoopts):
					print "##\tCode\t\t\tLength\tData"
					for i in protoopts:
						if i["opt_proto"] == 6:
							print str(i['optid']) + "\t", 
							if i['opt_code'] == 0:
								print "End of Option List",
							elif i['opt_code'] == 1:
								print "No Operation",
							elif i['opt_code'] == 2:
								print "Maximum Segment Size",
							elif i['opt_code'] == 3:
								print "WSOPT - Window Scale",
							elif i['opt_code'] == 4:
								print "SACK Permitted",
							elif i['opt_code'] == 5:
								print "SACK",
							elif i['opt_code'] == 6:
								print "Echo (obsoleted by option 8)",
							elif i['opt_code'] == 7:
								print "Echo Reply (obsoleted by option 8)",
							elif i['opt_code'] == 8:
								print "TSOPT - Time Stamp Option",
							elif i['opt_code'] == 9:
								print "Partial Order Connection Permitted",
							elif i['opt_code'] == 10:
								print "Partial Order Service Profile",
							elif i['opt_code'] == 14:
								print "TCP Alternate Checksum Request",
							elif i['opt_code'] == 15:
								print "TCP Alternate Checksum Data",
							elif i['opt_code'] == 18:
								print "Trailer Checksum Option",
							elif i['opt_code'] == 19:
								print "MD5 Signature Option",
							else:
								print "Suspicious...take a deeper look",
							print "\t\t" + str(i['opt_len']) + "\t" + str(i['opt_data'])
				else:
					print "None\n"
	                        print "\nFlags"
				print "--------"
				if temp['tcp_flags'] == 0:	
					print "None\n"
				else:	
					counter = int(temp['tcp_flags'])
					downcounter=7		
					tmp = 0
					binstr = ""
					while downcounter >= 0:
						tmp = counter / (2**downcounter)
						binstr = binstr + str(tmp)
						counter = counter % (2**downcounter)	
						downcounter = downcounter - 1
					tmpstr = ""
					print "RB 1\tRB 0\tURG\tACK\tPSH\tRST\tSYN\tFIN"
					for i in binstr:
						if i == "1":
							print "X\t",
						elif i == "0":
							print "\t",					
				print "\n"
			except:
		                print "TCP"
				print "--------"
		elif event['proto'] == "17":
			cur=db.cursor(MySQLdb.cursors.DictCursor)
		        query = "select udp_sport,udp_dport,udp_len,udp_csum from udphdr where udphdr.cid=" + cid + " and udphdr.sid=" + sid + ";"
			try: 
		                cur.execute(query)
		                temp = cur.fetchone()	
		                for i in temp.keys():
	       	 	                temp[i] = str(temp[i])
				print "UDP"     
				print "--------"
				print "Source Port\tDest Port\tLength\tChecksum"
				print temp['udp_sport'] + "\t\t" + temp['udp_dport'] + "\t\t" + temp['udp_len'] + "\t" + temp['udp_csum'] + "\n"
			except:
				print "UDP"     
				print "--------"

		print "DATA"
		print "--------"
		cur=db.cursor(MySQLdb.cursors.DictCursor)
		query = "select data_payload from data where data.cid=" + cid + " and data.sid=" + sid + ";"
		cur.execute(query)
		temp = cur.fetchone()
		tmpstr = ""									
	
		hexdata = ""
		asciidata = ""
	
		if temp:
			for i in temp['data_payload']:	
				tmpstr = tmpstr + i
			count = 0
			paylen = len(tmpstr)
			tmp = ""
			for i in range(0, paylen):
				if (count == paylen-1):
					fin = 0
					tmp = tmp + tmpstr[i]
					print tmp + "\t",
					print hextranslate(tmp)
					tmp = ""
					count = 0
				elif count < 19:
					tmp = tmp + tmpstr[i]
					count = count + 1
					fin = 1
				else:
					fin = 0
					tmp = tmp + tmpstr[i]
					print tmp + "\t", 
					print hextranslate(tmp)
					tmp = ""
					count = 0
			if fin == 1:
				print tmp + "\t",  
				print hextranslate(tmp)
			if options["eventaltviews"] == 'yes':
				print "\nDATA"
				print "--------"
				count = 0
				paylen = len(tmpstr)
				tmp = ""
				asciidata1 = ""
				for i in range(0, paylen):
		                        if (count == paylen-1):
						fin = 0 
		                                tmp = tmp + tmpstr[i]
		                                print hextranslate(tmp)
		                                tmp = ""  
		                                count = 0
		                        elif count < 119:
		                                tmp = tmp + tmpstr[i]
		                                count = count + 1
						fin = 1
		                        else:
						fin = 0
		                                tmp = tmp + tmpstr[i]
		                                print hextranslate(tmp)
		                                tmp = ""
		                                count = 0
		                if fin == 1:
       	 	                	print hextranslate(tmp)
		else:
			print "None\n"
	printtail()	
	
main()
